;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; SIMBOLOS PARA LA INICIALIZACION
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
MAX_ENTITIES    == 30
ENTITY_SIZE     == 31

.globl _m_entities
.globl direccion_jugador

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; MACROS para acceso a los datos
;; de las entidades 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.equ Ent_TYPE        , 0
.equ Ent_X           , 1
.equ Ent_Y           , 2
.equ Ent_VX          , 3
.equ Ent_VY          , 4
.equ Ent_W           , 5
.equ Ent_H           , 6
.equ Ent_SPRITE1     , 7
.equ Ent_SPRITE2     , 8
.equ Ent_AI1         , 9
.equ Ent_AI2         , 10
.equ Ent_ANIM1       , 11
.equ Ent_ANIM2       , 12
.equ Ent_ANIM_COUNT  , 13
.equ Ent_AI_COUNT    , 14
.equ Ent_COMPONENTS  , 15
.equ Ent_COLISION    , 16
.equ Ent_DIRECCION   , 17
.equ Ent_PREVIO      , 18
.equ Ent_PREVIO2     , 19
.equ Ent_PREVIO3     , 28
.equ Ent_PREVIO4     , 29
.equ Ent_OBJX        , 20
.equ Ent_OBJY        , 21
.equ Ent_AIPREV1     , 22
.equ Ent_AIPREV2     , 23
.equ Ent_PATROL1     , 24
.equ Ent_PATROL2     , 25
.equ Ent_AI_COUNT_O  , 26
.equ Ent_COOLDOWN    , 27
.equ Ent_COOLDOWN_O  , 30


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; TIPOS DE ENTIDADES
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
e_type_invalid      == 0x00
e_type_player       == 0x01
e_type_shot         == 0x02
e_type_soldier      == 0x04
e_type_object       == 0x08
e_type_rock         == 0x10
e_type_boss         == 0x40
e_type_dead         == 0x80
e_type_default      == 0xFF

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; DECLARACIONS GLOBALES DE LOS TIPOS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.globl e_type_invalid
.globl e_type_player
.globl e_type_dead
.globl e_type_shot
.globl e_type_soldier
.globl e_type_object
.globl e_type_default

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; COMPONENTES DE LAS ENTIDADES
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
e_cmp_render   == 0x01
e_cmp_movable  == 0x02
e_cmp_input    == 0x04
e_cmp_ai       == 0x08
e_cmp_animated == 0x10
e_cmp_collider == 0x20
e_cmp_default  == 0x00

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; DECLARACIONS GLOBALES DE LOS 
;; COMPONENTES
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.globl e_cmp_render
.globl e_cmp_movable
.globl e_cmp_input
.globl e_cmp_ai
.globl e_cmp_animated
.globl e_cmp_collider
.globl e_cmp_default

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; DECLARACIONS GLOBALES DE LAS
;; FUNCIONES QUE TRABAJAN SOBRE
;; LAS ENTIDADES
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.globl man_entity_create
.globl man_entity_destroy
.globl man_entity_set4destruction
.globl man_entity_forall
.globl man_entity_forall_matching
.globl man_entity_forall_pairs_matching
.globl man_entity_setSprite
.globl man_entity_setCooldown
.globl man_entity_setCooldown_shot
.globl man_entity_setIA
.globl man_entity_setPosition
.globl man_entity_setPatrol
.globl forall_filter
.globl forall_function