.module Game_Manager

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;      INCLUDES        ;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.include "entity.inc"
.include "cpctelera.inc"
.include "sprites.inc"
.include "music.inc"
.include "HUD.inc"
.include "IA.inc"
.include "patrol.inc"
.globl int_counter
.globl powerup_multi
.globl powerup_metr
.globl powerup_multi_timer
.globl powerup_metr_timer
.globl erase_powerup
.globl enemies_onscreen
.globl wave_finished
.globl temp_azul
.globl temp_roja
.globl temp_verde
.globl check_if_mute
.globl sys_music_set_music

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;  Funciones Propias ;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.globl sys_render_init
.globl sys_render_init_game
.globl sys_ai_update
.globl sys_animations_update
.globl sys_render_update
.globl sys_physics_update
.globl sys_collision_update
.globl man_entity_update
.globl man_game_entity_destroy
.globl man_game_create_template_entity
.globl autodestroy_ai
.globl cpct_scanKeyboard_asm
.globl _sizeArray
.globl m_num_entities
.globl m_next_free_entity
.globl reset_HUD
.globl _main
.globl man_level_prepare
.globl man_level_update
.globl man_level_next
.globl spawned_enemies
.globl empieza_next_level
.globl man_level_reset
.globl coordenada_Y_original
.globl show_victory_screen

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;  Variables Propias ;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

direccion_jugador: .dw 0x000

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;    PLANTILLAS     ;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;//Plantilla PIEDRA
init_rock::
    .db e_type_rock                     ;type      0
    .db 0                               ;x         1
    .db 0                               ;y         2
    .db 0                               ;vx        3
    .db 0                               ;vy        4
    .db SPR_PIEDRA_W                    ;w         5
    .db SPR_PIEDRA_H                    ;h         6
    .dw sprite_piedra                   ;sprite    7-8
    .dw 0x0000                          ;ai        9-10
    .dw 0x0000                          ;anim      11-12
    .db 0                               ;count     13
    .db 0                               ;aik       14 TIEMPO DE VIDA DE LA BALA
    .db e_cmp_render                    ;cmp       15
    .db 0                               ;coll      16
    .db 0                               ;dirr      17
    .db 0xE8                            ;prev      18
    .db 0xC2                            ;prev2     19
    .db 0x00                            ;objx      20
    .db 0x00                            ;objy      21
    .dw 0x0000                          ;iaprevia  22 - 23
    .dw 0x0000                          ;patrol    24 - 25
    .db 0                               ;aik_origin     26
    .db 0                               ;cooldown  27
    .db 0x0                             ;prev3     28
    .db 0xc2                            ;prev4     29
    .db 0                               ;cooldownO 30

;//Plantilla OBJETO
init_object::
    .db e_type_object                   ;type      0
    .db 0                               ;x         1
    .db 0                               ;y         2
    .db 0                               ;vx        3
    .db 0                               ;vy        4
    .db SPR_OBJECT_W                    ;w         5
    .db SPR_OBJECT_H                    ;h         6
    .dw sprites_roja                    ;sprite    7-8
    .dw 0x0000                          ;ai        9-10
    .dw 0x0000                          ;anim      11-12
    .db 0                               ;count     13
    .db 0                               ;aik       14 TIEMPO DE VIDA DE LA BALA
    .db e_cmp_render | e_cmp_collider   ;cmp       15
    .db e_type_player                   ;coll      16
    .db 0                               ;dirr      17
    .db 0xE8                            ;prev      18
    .db 0xC2                            ;prev2     19
    .db 0x00                            ;objx      20
    .db 0x00                            ;objy      21
    .dw 0x0000                          ;iaprevia  22 - 23
    .dw 0x0000                          ;patrol    24 - 25
    .db 0                               ;aik_origin     26
    .db 0                               ;cooldown  27
    .db 0x0                             ;prev3     28
    .db 0xc2                            ;prev4     29
    .db 0                               ;cooldownO 30

;//Plantilla SHOT JUGADOR
init_player_shot::
    .db e_type_shot                     ;type      0
    .db 0                               ;x         1
    .db 0                               ;y         2
    .db 0                               ;vx        3
    .db 0                               ;vy        4
    .db SPR_SHOT_W                      ;w         5
    .db SPR_SHOT_H                      ;h         6
    .dw sprites_shot                    ;sprite    7-8
    .dw autodestroy_ai                  ;ai        9-10
    .dw 0x000                           ;anim      11-12
    .db 0                               ;count     13
    .db 30                              ;aik       14 TIEMPO DE VIDA DE LA BALA
    .db 0b00101011                      ;cmp       15
    .db 0                               ;coll      16
    .db 0                               ;dirr      17
    .db 0xE8                            ;prev      18
    .db 0xC2                            ;prev2     19
    .db 0x00                            ;objx      20
    .db 0x00                            ;objy      21
    .dw 0x0000                          ;iaprevia  22 - 23
    .dw 0                               ;patrol    24 - 25
    .db 0                               ;aik_origin     26
    .db 0                               ;cooldown  27
    .db 0x0                             ;prev3     28
    .db 0xc2                            ;prev4     29
    .db 0                               ;cooldownO 30

;//Plantilla JUGADOR
init_jugador::
    .db e_type_player                                                   ;type      0
    .db 75                                                              ;x         1
    .db Player_Y                                                        ;y         2
    .db 0                                                               ;vx        3
    .db 0                                                               ;vy        4
    .db SPR_JUGADOR_W                                                   ;w         5
    .db SPR_JUGADOR_H                                                   ;h         6
    .dw sprites_soldado0                                                ;sprite    7-8
    .dw 0x0000                                                          ;ai        9-10
    .dw anim_enemy_right                                                ;anim      11-12
    .db 1                                                               ;count     13
    .db 0                                                               ;aik       14
    .db e_cmp_render | e_cmp_movable | e_cmp_input | e_cmp_animated | e_cmp_collider    ;cmp       15  
    .db 0                                                               ;coll      16
    .db 0                                                               ;dir       17
    .db 0xE8                                                            ;prev      18
    .db 0xC2                                                            ;prev2     19
    .db 0x00                                                            ;objx      20
    .db 0x00                                                            ;objy      21
    .dw 0x0000                                                          ;iaprevia  22 - 23
    .dw 0x0000                                                          ;patrol    24 - 25
    .db 0                                                               ;aik_origin     26
    .db 20                                                              ;cooldown  27
    .db 0x0                                                             ;prev3     28
    .db 0xc2                                                            ;prev4     29
    .db 20                                                              ;cooldownO  30

;//Plantilla SOLDADO IA
init_soldado:: 
    .db e_type_soldier                                                ;type      0
    .db 0                                                             ;x         1
    .db 0                                                             ;y         2
    .db 0                                                             ;vx        3
    .db 0                                                             ;vy        4
    .db SPR_BANDIDO_W                                                 ;w         5
    .db SPR_BANDIDO_H                                                 ;h         6 
    .dw sprite_bandido0                                               ;sprite    7-8
    .dw 0x0000                                                        ;ai        9-10
    .dw anim_bandido_right                                            ;anim      11-12
    .db 1                                                             ;count     13     Si esta a cero el enemigo no se cambia
    .db 1                                                             ;aik       14
    .db e_cmp_render | e_cmp_ai | e_cmp_animated | e_cmp_movable | e_cmp_collider     ;cmp       15  
    .db 0                                                             ;coll      16
    .db 0                                                             ;dir       17
    .db 0xE8                                                          ;prev      18
    .db 0xc2                                                          ;prev2     19
    .db 0x00                                                          ;objx      20
    .db 0x00                                                          ;objy      21
    .dw 0x0000                                                        ;iaprevia  22 - 23
    .dw 0x0000                                                        ;patrol    24 - 25 AUXILIAR PARA IA SNIPER
    .db 40                                                           ;aik_origin     26
    .db 10                                                            ;cooldown  27
    .db 0x0                                                           ;prev3     28
    .db 0xc2                                                          ;prev4     29 
    .db 10                                                            ;cooldownO 30


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;  Funciones ;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Funcion 'Man_Gampeplay'
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Bucle de control de juego infinito
;; 
man_gameplay::
    loop:
        call man_level_update
        call sys_ai_update
        call sys_physics_update
        call sys_animations_update
        call sys_render_update
        call man_entity_update
        call sys_collision_update

        ld a, (powerup_multi_timer)
        cp #0
        jr z, no_hay_multi
            dec a
            ld (powerup_multi_timer),a
            cp #0
            jp nz,no_hay_multi
                ld (powerup_multi),a
                ld hl,#0
                call erase_powerup
        no_hay_multi:
        ld a, (powerup_metr_timer)
        cp #0
        jr z, no_hay_metr
            dec a
            ld (powerup_metr_timer),a
            cp #0
            jp nz,no_hay_metr
                ld (powerup_metr),a
                ld hl,#4
                call erase_powerup
                ld ix, (direccion_jugador)
                ld Ent_COOLDOWN_O(ix),#20
        no_hay_metr:

        ld a, (enemies_onscreen)
        or a
        jp nz, no_terminar_wave ; Si el número de enemigos es 0, ir a la pantalla de victoria
            ld a, (wave_finished)
            or a
            jp z, no_terminar_wave
            jp show_victory_screen
        no_terminar_wave:
        
        call check_if_mute
    jp loop
ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Funcion 'Man_Game_init'
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; No tiene INPUT
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Inicializa el sistema de render
;; Crea una primera entidad (Jugador)
;; 
man_game_init::
    ;ld a,#1                    ;PROTECCION CONTRA JU-
    ;ld a,#2                    ;PROTECCION CONTRA JU-
    call sys_music_set_music
    call man_level_prepare
    call sys_render_init_game

    ld  h, #30
    ld  l, #50
    call man_entity_setPosition

    ;JUGADOR
    ld hl, #init_jugador
    call man_game_create_template_entity
    ld  (direccion_jugador), ix
ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Funcion 'Espera'
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; INPUT: (H) Numero de veces que se 
;;            repite el bucle
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Bucle de espera para sincronizacion
;;
espera::
	halt
    halt
    call cpct_waitVSYNC_asm
	dec h
	jp nz, espera
ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Funcion 'Man_Game_Create_Template_Entity'
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; INPUT: (HL) Puntero a la plantilla
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Crea una nueva entidad con la plantilla
;; especificada en el registro (HL)
;;
;; Devuelve un puntero a la entidad creada en IX
;;
;; Destruye BC, AF
;;
man_game_create_template_entity:
    push hl
    call man_entity_create  
    pop hl
    push hl
    ld bc, #ENTITY_SIZE
    push de
    call cpct_memcpy_asm    ;(2B DE) to	Pointer to the destination (first byte where bytes will be written)
                            ;(2B HL) from	Pointer to the source (first byte from which bytes will be read)
                            ;(2B BC) size	Number of bytes to be set (>= 1)
    pop ix
    pop hl
ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Funcion 'Man_Game_Player_Shot'
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; INPUT: (IX) Puntero a jugador
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Pemite al jugador disparar una bala
;; 
man_game_player_shot::
    ld  a, Ent_COOLDOWN(ix)
    cp  #0
    jp  nz, no_disparo
        ld  a, Ent_COOLDOWN_O(ix)
        ld Ent_COOLDOWN(ix), a
        call generar_bala
        ld a, (powerup_multi)
        cp #2
        jr nz, no_multi_shot
            call generar_bala_multi
        no_multi_shot:
    no_disparo:
ret

generar_bala_multi:
    push ix
    pop iy

    ld a, Ent_DIRECCION(iy)
    cp #3
    jp z, aparezco_arriba_izquierda
    jp nc, segunda_mitad_multi
        cp #1
        jp z, aparezco_abajo_izquierda
        jp nc, aparezco_izquierda
        jp aparezco_abajo
    segunda_mitad_multi:
        cp #5
        jp z, aparezco_arriba_derecha
        jp nc, segunda_segunda_mitad_multi
        jp aparezco_arriba
        segunda_segunda_mitad_multi:
            cp #6
            jp z, aparezco_derecha
            jp aparezco_abajo_derecha

generar_bala::
    push ix
    pop iy
    
    ld a, Ent_DIRECCION(iy)
    cp #3
    jp z, aparezco_abajo_derecha
    jp nc, segunda_mitad
        cp #1
        jp z, aparezco_arriba_derecha
        jp nc, aparezco_derecha
        jp aparezco_arriba
    segunda_mitad:
        cp #5
        jp z, aparezco_abajo_izquierda
        jp nc, segunda_segunda_mitad
        jp aparezco_abajo
        segunda_segunda_mitad:
            cp #6
            jp z, aparezco_izquierda
            jp aparezco_arriba_izquierda

aparezco_arriba:
    ld a, Ent_Y(iy)
    sub #8
    cp #37
    jp nc, spawn_arriba
        jp final_tiro
    spawn_arriba:
    call create_bullet
    ld a, Ent_Y(iy)
    sub #10
    ld Ent_Y(ix), a
    ld a, Ent_X(iy)
    add a, #3
    ld Ent_X(ix), a
    ld Ent_VX(ix), #0
    ld Ent_VY(ix), #-3
    jp final_tiro

aparezco_arriba_derecha:
    ld a, Ent_X(iy)
    add #7
    cp #147
    jp c, spawn_arriba_derecha
        jp final_tiro
    spawn_arriba_derecha:
    call create_bullet
    ld a, Ent_Y(iy)
    add #5
    ld Ent_Y(ix), a
    ld a, Ent_X(iy)
    add #7
    ld Ent_X(ix), a
    ld Ent_VX(ix), #3
    ld Ent_VY(ix), #-3
    jp final_tiro

aparezco_derecha:
    ld a, Ent_X(iy)
    add #7
    cp #147
    jp c, spawn_derecha
        jp final_tiro
    spawn_derecha:

    call create_bullet

    ld a, Ent_Y(iy)
    add #5
    ld Ent_Y(ix), a

    ld a, Ent_X(iy)
    add #7
    ld Ent_X(ix), a
    ld Ent_VX(ix), #3

    jp final_tiro

aparezco_abajo_derecha:
    ld a, Ent_X(iy)
    add #7
    cp #147
    jp c, spawn_abajo_derecha
        jp final_tiro
    spawn_abajo_derecha:
    call create_bullet
    ld a, Ent_Y(iy)
    add #14
    ld Ent_Y(ix), a

    ld a, Ent_X(iy)
    add a, #7
    ld Ent_X(ix), a
    ld Ent_VX(ix), #3
    ld Ent_VY(ix), #3
    jp final_tiro

aparezco_abajo:
    ld a, Ent_Y(iy)
    add #14
    cp #175
    jp c, spawn_abajo
        jp final_tiro
    spawn_abajo:
    call create_bullet
    ld a, Ent_Y(iy)
    add #14
    ld Ent_Y(ix), a
    ld a, Ent_X(iy)
    ld Ent_X(ix), a
    ld Ent_VX(ix), #0
    ld Ent_VY(ix), #3
    jp final_tiro

aparezco_abajo_izquierda:
    ld a, Ent_X(iy)
    sub #2
    cp #11
    jp nc, spawn_abajo_izquierda
        jp final_tiro
    spawn_abajo_izquierda:
    call create_bullet
    ld a, Ent_Y(iy)
    add #14
    ld Ent_Y(ix), a

    ld a, Ent_X(iy)
    sub #2
    ld Ent_X(ix), a
    ld Ent_VX(ix), #-3
    ld Ent_VY(ix), #3
    jp final_tiro

aparezco_izquierda:
    ld a, Ent_X(iy)
    sub #2
    cp #11
    jp nc, spawn_izquierda
        jp final_tiro
    spawn_izquierda:
    call create_bullet
    ld a, Ent_Y(iy)
    add #5
    ld Ent_Y(ix), a
    ld a, Ent_X(iy)
    sub #2
    ld Ent_X(ix), a
    ld Ent_VX(ix), #-3
    jp final_tiro

aparezco_arriba_izquierda:
    ld a, Ent_X(iy)
    sub #2
    cp #11
    jp nc, spawn_arriba_izquierda
        jp final_tiro
    spawn_arriba_izquierda:
    call create_bullet
    ld a, Ent_Y(iy)
    add #5
    ld Ent_Y(ix), a
    ld a, Ent_X(iy)
    sub #2
    ld Ent_X(ix), a
    ld Ent_VX(ix), #-3
    ld Ent_VY(ix), #-3
    jp final_tiro
    final_tiro:
    call sys_music_play_shot
    push iy
    pop ix
ret

create_bullet:
    ld hl, #init_player_shot
    call man_game_create_template_entity
    ld  a, Ent_TYPE(iy)
    cp  #e_type_player
    jp  nz, no_dispara_jugador
        ld  Ent_COLISION(ix), #e_type_soldier
        jp  saltar_colision
    no_dispara_jugador:
        ld  Ent_COLISION(ix), #e_type_player
    saltar_colision:
    ld a, Ent_DIRECCION(iy)
    ld Ent_DIRECCION(ix), a
ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Funcion 'Man_Game_Entity_Destroy'
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 
;; INPUT:  (IX) Direccion de memoria de
;;              la entidad
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Pone la entidad que se le pasa lista
;; para ser destruida al final del bucle
;; de juego
;;
man_game_entity_destroy::

    call man_entity_set4destruction     ; Marcamos la entidad para destruir
ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Funcion 'man_game_reset'
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 
;; INPUT:  (A) si estamos muertos o no
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Reiniciamos la partida
;; 
;; 
;;
man_game_reset::
    push af

    ;libero memoria de las entidades
    ld a, #0
    ld (m_num_entities), a
    ld hl, #_m_entities
    ld (m_next_free_entity), hl

    ld a, #107
    ld (coordenada_Y_original), a

    ld a,#1
    ld (powerup_multi_timer), a ;reiniciar powerup
    ld (powerup_metr_timer), a ;reiniciar powerup

    ld hl, #_m_entities   
    ld de, #_m_entities+1 
    ld bc, #_sizeArray-1  
    ld (hl), #0x0         
    ldir      

    pop af

    cp #0
    jr nz, is_defeat
        call man_level_reset
        call  _main
    is_defeat:
        call man_level_next
        jp empieza_next_level
    
ret