.module Level_Manager
.include "entity.inc"
.include "IA.inc"
.include "sprites.inc"
.include "HUD.inc"

.globl init_soldado
.globl man_game_create_template_entity
.globl man_patrol_Get_Patrol
.globl spawned_enemies
.globl m_hud
.globl _tilemap_01
.globl init_rock
MAX_ENEMIES_ONSCREEN = 4
enemies_onscreen:: .db 0
spawned_enemies:: .db 0
wave_enemy_amount:: .db 0
wave_finished:: .db 0
bullet_cooldown: .db 20
spawn_cooldown: .db 100
spawn_cooldown_amount: .db 100

ia_cooldown: .db 20

current_tilemap:: .dw _tilemap_01
piedra1:: .db 0
piedra2:: .db 0
piedra3:: .db 0
wave_pointer: .dw wave1
temp_verde:: .db #2
temp_azul::  .db #3
temp_roja::  .db #4

.include "pieces/waves.s"

.globl _tilemap_02
.globl _tilemap_03

plantilla_level_reset:
    .db 0               ;enemies_onscreen
    .db 0               ;spawned_enemies
    .db 0               ;wave_enemy_amount
    .db 0               ;wave_finished
    .db 20              ;bullet_cooldown
    .db 100             ;spawn_cooldown
    .db 100             ;spawn_cooldown_amount
    .db 20              ;ia_cooldown
    .dw #_tilemap_01    ;tilemap
    .db 0               ;piedra1
    .db 0               ;piedra2
    .db 0               ;piedra3
    .dw wave1           ;wave_pointer
    .db 2               ;temp_verde
    .db 3               ;temp_azul
    .db 4               ;temp_roja

man_level_reset::
    ld hl, #plantilla_level_reset        ; apunta a los valores iniciales del HUD
    ld de, #enemies_onscreen             ; apunta al inicio del HUD en la memoria
    ld bc, #18                           ; 9 bytes de datos para copiar  
    ldir                                 ; copia los valores iniciales al HUD
ret

;; Cambias la aparicion de pociones
;;      A -> VERDE
;;      B -> AZUL
;;      C -> ROJA
man_level_count_poti::
    ld (temp_verde),  a
    ld a, b
    ld (temp_azul ),  a
    ld a, c
    ld (temp_roja ),  a
    ret

man_level_next::
    ld a, (ia_cooldown)
    cp #2
    ld (ia_cooldown), a
    no_baja_cadencia:
ret
man_level_prepare::  
    ld a,#0
    ld (wave_finished),a
    ld (spawned_enemies),a

    ld hl, #wave_pointer
    ld e, (hl)
    inc hl
    ld d, (hl)
    ld h,d
    ld l,e
    ld a,(hl)
    inc hl
    ld (wave_pointer),hl
    ld (wave_enemy_amount),a

    ld ix, #m_hud
    ld a, 2(ix)
    cp #2
    jp z, generar_rocas2
    jp c, generar_rocas1
        ld a,#25
        ld (spawn_cooldown_amount),a
        ld de,#_tilemap_03
        ld (current_tilemap), de
        ld d,#24
        ld e,#110
        ld b,#74
        ld c,#80
        ld h,#124
        ld l,#110
        call generate_rocks
        jp final_generar_rocas
    generar_rocas2:
        ld a,#60
        ld (spawn_cooldown_amount),a
        ld de,#_tilemap_02
        ld (current_tilemap), de
        ld d,#28
        ld e,#100
        ld b,#60
        ld c,#60
        ld h,#112
        ld l,#90
        call generate_rocks
        jp final_generar_rocas
    generar_rocas1:
        ld d,#22
        ld e,#140
        ld b,#50
        ld c,#40
        ld h,#130
        ld l,#120
        call generate_rocks
    final_generar_rocas:
ret
generate_rocks:
    push hl
    push bc
    push de
    ld hl, #init_rock
    call man_game_create_template_entity
    pop de
    ld Ent_X(ix),d
    ld Ent_Y(ix),e
    call man_game_create_template_entity
    pop bc
    ld Ent_X(ix),b
    ld Ent_Y(ix),c
    call man_game_create_template_entity
    pop hl
    ld Ent_X(ix),h
    ld Ent_Y(ix),l
ret

man_level_update::
    ld a, (spawn_cooldown)
    dec a
    cp #0
    jp nz, nospawn
        ld a, (enemies_onscreen)
        cp #MAX_ENEMIES_ONSCREEN
        jp z, no_cabe
        jp nc, no_cabe
            call man_level_spawn_enemy
            ld a, (spawn_cooldown_amount)
        no_cabe:
    nospawn:
    ld (spawn_cooldown), a
ret

man_level_spawn_enemy::
    ld a,(wave_finished)
    cp #1
    jp z,no_borrar_patrulla

    ld a, (enemies_onscreen)
    inc a 
    ld (enemies_onscreen),a
    ld a, (spawned_enemies)
    inc a 
    ld (spawned_enemies),a
    ld h,a
    ld a,(wave_enemy_amount)
    cp h
    jp nz,continue_spawn
        ld a,#1
        ld (wave_finished),a
    continue_spawn:

    ld hl, #init_soldado
    call man_game_create_template_entity
    ld  a, (ia_cooldown)
    call man_entity_setCooldown
    add #5
    call man_entity_setCooldown_shot

    ld hl, (wave_pointer)
    ld a, (hl)
    cp #2
    jp z,spawn_patrol
    jp c,enemigo_natural
        enemigo_bandido:
            cp #4
            jp z,spawn_jefe 
            spawn_sniper:
                ld hl,#sys_ia_sniper
                jp end_choose_ia
            spawn_jefe:
                ld hl,#sys_ia_boss
                jp end_choose_ia
            spawn_patrol:
                ld hl,#sys_ia_patrol
                jp end_choose_ia
        enemigo_natural:
            cp #1
            jp z,spawn_seguidor
            spawn_bouncer:
                ld hl,#sys_ia_bouncer 
                jp end_choose_ia
            spawn_seguidor:
                ld hl,#sys_ia_seguir_jugador
                jp end_choose_ia
    end_choose_ia:
    call man_entity_setIA

    ld hl, (wave_pointer)
    inc hl
    ld a,(hl)
    inc hl
    ld (wave_pointer), hl
    cp #85
    jp c, spawn_left
    cp #170
    jp c, spawn_top
    spawn_right:;80min 115max ;170-255
        ld Ent_X(ix), #154-SPR_SOLDADO_W*2
        srl a
        srl a
        add #45
        ld Ent_Y(ix), a

        ld de,#ENTITY_SIZE*2
        call set_objective_rock

        ld  a, #2
        call man_patrol_Get_Patrol
        call man_entity_setPatrol
    jp end_spawn
    spawn_left:;80min 115max ;0-84
        ld Ent_X(ix), #8
        srl a
        srl a
        add #87
        ld Ent_Y(ix), a

        ld de,#0
        call set_objective_rock

        ld  a, #0
        call man_patrol_Get_Patrol
        call man_entity_setPatrol
    jp end_spawn
    spawn_top:;59min 91max ;85-169
        ld Ent_Y(ix), #27
        srl a
        srl a
        add #45
        ld Ent_X(ix), a
        cp #75
        jp c, izquierda_bouncer
        derecha_bouncer:
            ld a,#VELOCIDAD_IA_BOUNCER_STOMP
            ld Ent_VX(ix), a
        jp saltar_random_dir_bouncer
        izquierda_bouncer:
            ld a,#-VELOCIDAD_IA_BOUNCER_STOMP
            ld Ent_VX(ix), a
        saltar_random_dir_bouncer:

        ld de,#ENTITY_SIZE
        call set_objective_rock

        ld  a, #1
        call man_patrol_Get_Patrol
        call man_entity_setPatrol
    end_spawn: 
        ld a, Ent_AI1(ix)
        cp #<sys_ia_patrol
        jp z, no_borrar_patrulla
            ld Ent_PATROL1(ix), #0
            ld Ent_PATROL2(ix), #0
    no_borrar_patrulla:
ret

set_objective_rock:
    ld  iy, #_m_entities
    add iy,de
    ld  a,  Ent_X(iy)
    ld  Ent_OBJX(ix), a
    ld  a,  Ent_Y(iy)
    sub #10
    ld  Ent_OBJY(ix), a
ret

;REQUIERE DIVISOR EN DE Y DIVIDENDO EN HL, DEVUELVE RESTO EN HL
;DESTRUYE de,hl,bc,a
modulo::
    ld a,e                         
    or a                           
    ret z

    ld bc,#-1                       
    DivLoop::                      
    sbc hl,de                      
    inc bc                         
    jp nc,DivLoop

    add hl,de
ret