.module SCREENS_Manager

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;      INCLUDES        ;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.include "entity.inc"
.include "cpctelera.inc"
.include "sprites.inc"
.include "HUD.inc"
.include "cpctelera.h.s"

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;  Funciones Propias ;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.globl show_defeat_screen
.globl show_start_screen
.globl show_start_game
.globl sys_render_init
.globl man_game_reset
.globl man_HUD_forall_level
.globl man_HUD_forall_score
.globl _myDrawStringM0
.globl sys_render_HUD
.globl man_HUD_forall_life
.globl current_buffer
.globl sys_render_paint
.globl _g_masktable
.globl cpct_drawSpriteMaskedAlignedTable_asm
.globl _spr_button
.globl sys_music_set_menu
.globl sys_music_set_music
.globl check_if_mute
.globl man_level_count_poti

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Funcion 'pintar_texto_seguido_enpantalla'
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; INPUT:  (IY) Primera linea de texto
;;         ( B) Posicion en Y
;;         ( C) Posicion en X
;;         ( A) Número de linea de texto
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Inicializa la pantalla de inicio
;;
pintar_texto_seguido_enpantalla::
    seguir_texto:
    push af
    push bc
    ld   de, #CPCT_VMEM_START_ASM ;; Puntero al principio de la memoria
    call cpct_getScreenPtr_asm    ;; Calcula la direccion de memoria a pintar y la devuelve en HL
    call _myDrawStringM0          ;; Draw the string
    pop  bc
    pop  af
    dec  a
    jp   z,  fin_del_texto
        push af
        ld   a, b
        add  a, #20
        ld   b, a
        pop  af
        inc  iy
    jp   seguir_texto

    fin_del_texto:
    ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Funcion 'texto_blanco'
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Pone el el texto a blanco
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
texto_blanco::
    ld    h, #14                  ;; Color de Fondo
    ld    l, #15                  ;; Color de las letras
    call cpct_setDrawCharM0_asm   ;; Set draw char colours
    ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Funcion 'texto_verde'
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Pone el el texto a verde
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
texto_verde::
    ld    h, #14                  ;; Color de Fondo
    ld    l, #6                   ;; Color de las letras
    call cpct_setDrawCharM0_asm   ;; Set draw char colours

    ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Funcion 'texto_amarillo'
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Pone el el texto a verde
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
texto_amarillo::
    ld    h, #14                  ;; Color de Fondo
    ld    l, #1                   ;; Color de las letras
    call cpct_setDrawCharM0_asm   ;; Set draw char colours
    ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Funcion 'texto_rojo'
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Pone el el texto a rojo
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
texto_rojo::
    ld    h, #14                  ;; Color de Fondo
    ld    l, #5                   ;; Color de las letras
    call cpct_setDrawCharM0_asm   ;; Set draw char colours
    ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Funcion 'limpiar_pantalla'
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Limpia la pantalla y la deja en negro
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
limpiar_pantalla::

    ld hl, #0xC000      
    ld de, #0xC001      
    ld bc, #0x4000 -1
    ld (hl), #0x3f
    ldir

    ret

pintar_estrella::
    ld c, #8     ; Ancho del sprite en bytes
    ld b, #17    ; Altura del sprite en bytes
    call cpct_drawSprite_asm
ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Funcion 'pintar_raya'
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; INPUT:  (B)   Posicion Y
;;         (C)   Posicion X
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Pinta la raya de los niveles
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
stringBar: .asciz "-"
pintar_raya::
    ld   iy, #stringBar
    ld   de, #CPCT_VMEM_START_ASM ;; Puntero al principio de la memoria
    call cpct_getScreenPtr_asm    ;; Calcula la direccion de memoria a pintar y la devuelve en HL
    call _myDrawStringM0          ;; Draw the string
    ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Funcion 'show_start_screen'
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; No tiene INPUT
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Inicializa la pantalla de inicio
;;

text_game1: .asciz  "SHERIFF DUTY"
text_space: .asciz  "SPACE" 
text_lore: .asciz  "LORE" 
text_l: .asciz  "L" 

show_start_screen::
    ld a,#0
    ld (showing_lore),a
    call sys_music_set_menu
    ld l, #0x30
    call cpct_setVideoMemoryPage_asm

    call sys_render_init ;iniciamos el render
    call limpiar_pantalla
    
    ;; PINTAMOS LAS ESTRELLAS
    ld hl, #_spr_estrella ; Dirección en memoria de la imagen
    ld de, #0xC000        ; Dirección en memoria de la pantalla donde quieres mostrar la imagen
    call pintar_estrella

    ld hl, #_spr_estrella ; Dirección en memoria de la imagen
    ld de, #0xC048        ; Dirección en memoria de la pantalla donde quieres mostrar la imagen
    call pintar_estrella

    ;; PINTAMOS EL TITULO DEL JUEGO
    call texto_blanco
    ld    b, #5                   ;; Coordenada Y
    ld    c, #16                  ;; Coordenada X
    ld   iy, #text_game1          ;; Puntero al string
    ld    a, #1
    call pintar_texto_seguido_enpantalla
    ld    b, #179                  ;; Coordenada Y
    ld    c, #7                   ;; Coordenada X
    ld   iy, #text_lore    ;; Puntero al string
    ld    a, #1
    call pintar_texto_seguido_enpantalla
    ;; PINTAMOS LAS POCIONES
    ld    b, #107                  ;; Coordenada Y
    ld    c, #35                   ;; Coordenada X
    ld   iy, #text_controls_red    ;; Puntero al string
    ld    a, #3
    call pintar_texto_seguido_enpantalla
    ld    b, #179                  ;; Coordenada Y
    ld    c, #62                   ;; Coordenada X
    ld   iy, #text_controls_mute    ;; Puntero al string
    ld    a, #1
    call pintar_texto_seguido_enpantalla

    ld    bc, #_vaso_0
    call  pintar_poti
    ld    bc, #_vaso_1
    call  pintar_poti
    ld    bc, #_vaso_2
    call  pintar_poti

    ; Imprimir  Q
    ;           A
    ; Imprimir OP
    ; Imprimir SPACE
    ld    h, #15                  ;; Color de Fondo
    ld    l, #14                  ;; Color de las letras
    call cpct_setDrawCharM0_asm   ;; Set draw char colours
    call draw_keys
    ld    b, #35                  ;; Coordenada Y
    ld    c, #32                   ;; Coordenada X
    ld   iy, #text_controls_q    ;; Puntero al string
    ld    a, #1
    call pintar_texto_seguido_enpantalla
    ld    b, #50                  ;; Coordenada Y
    ld    c, #32                   ;; Coordenada X
    ld   iy, #text_controls_a    ;; Puntero al string
    ld    a, #1
    call pintar_texto_seguido_enpantalla
    ld    b, #35                  ;; Coordenada Y
    ld    c, #17                   ;; Coordenada X
    ld   iy, #text_controls_o    ;; Puntero al string
    ld    a, #1
    call pintar_texto_seguido_enpantalla
    ld    b, #35                  ;; Coordenada Y
    ld    c, #24                   ;; Coordenada X
    ld   iy, #text_controls_p    ;; Puntero al string
    ld    a, #1
    call pintar_texto_seguido_enpantalla
    ld    b, #179                  ;; Coordenada Y
    ld    c, #1                   ;; Coordenada X
    ld   iy, #text_l    ;; Puntero al string
    ld    a, #1
    call pintar_texto_seguido_enpantalla
    ld    b, #179                  ;; Coordenada Y
    ld    c, #56                   ;; Coordenada X
    ld   iy, #text_controls_m    ;; Puntero al string
    ld    a, #1
    call pintar_texto_seguido_enpantalla

    ;; PINTAMOS LA TECLA DE SPACE
    call texto_amarillo
    ld    b, #190                 ;; Coordenada Y
    ld    c, #30                  ;; Coordenada X
    ld   iy, #text_space         ;; Puntero al string
    ld    a, #1
    call pintar_texto_seguido_enpantalla


    ld de,#0xcA66
    ld a,#0x33
    ld c,#8
    ld b,#10
    call cpct_drawSolidBox_asm      ;(2B DE) memory	Video memory pointer to the upper left box corner byte
                                    ;(1B A ) colour_pattern	1-byte colour pattern (in screen pixel format) to fill the box with
                                    ;(1B C ) width	Box width in bytes [1-64] (Beware!  not in pixels!)
                                    ;(1B B ) height	Box height in bytes (>0)

    
    ld hl,#_key
    ld de,#0xc217
    ld c,#2
    ld b,#14
    call cpct_drawSprite_asm        ;(2B HL) sprite	Source Sprite Pointer (array with pixel data)
                                    ;(2B DE) memory	Destination video memory pointer
                                    ;(1B C ) width	Sprite Width in bytes [1-63] (Beware, not in pixels!)
                                    ;(1B B ) height	Sprite Height in bytes (>0)

    ld hl,#_spr_joy
    ld de,#0xc1C6
    ld c,#4
    ld b,#8
    call cpct_drawSprite_asm        ;(2B HL) sprite	Source Sprite Pointer (array with pixel data)
                                    ;(2B DE) memory	Destination video memory pointer
                                    ;(1B C ) width	Sprite Width in bytes [1-63] (Beware, not in pixels!)
                                    ;(1B B ) height	Sprite Height in bytes (>0)

    ld hl,#_spr_button
    ld de,#0xd26B
    ld c,#1
    ld b,#2
    call cpct_drawSprite_asm        ;(2B HL) sprite	Source Sprite Pointer (array with pixel data)
                                    ;(2B DE) memory	Destination video memory pointer
                                    ;(1B C ) width	Sprite Width in bytes [1-63] (Beware, not in pixels!)
                                    ;(1B B ) height	Sprite Height in bytes (>0)

    ;; ESPERAMOS EL TECLADO
    call esperar_tecla
ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Funcion 'pintar_poti'
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Bucle que pinta los sprites en pantalla
;;

coordenada_Y_original:: .db #107
pintar_poti::

    ; Pintar los prites de las potis
    push  bc
    ld   de, #CPCT_VMEM_START_ASM    ;; Puntero al principio de la memoria
    ld    a, (coordenada_Y_original) ;; Coordenada Y
    ld    b, a                       ;; Coordenada Y
    ld    c, #23                     ;; Coordenada X
    call cpct_getScreenPtr_asm       ;; Calcula la dirección de memoria a pintar y la devuelve en HL
    pop   bc
    ld d,h
    ld e,l
    ;ld    bc, #_vaso_0
    ld l, #SPR_OBJECT_W
    ld h, #SPR_OBJECT_H
    push hl
    pop ix
    ld h, #>_g_masktable
    ld l, #<_g_masktable
    ;(2B BC) psprite	Source Sprite Pointer
    ;(2B DE) pvideomem	Destination video memory pointer
    ;(1B IXL) width	Sprite Width in bytes (>0) (Beware, not in pixels!)
    ;(1B IXH) height	Sprite Height in bytes (>0)
    ;(2B HL) pmasktable0	Pointer to an Aligned Mask Table for transparencies with palette index 0
    call cpct_drawSpriteMaskedAlignedTable_asm

    ld  a, (coordenada_Y_original)
    add #20
    ld  (coordenada_Y_original), a

    ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Funcion 'show_start_game'
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; No tiene INPUT
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; CONTROLA LA PANTALLA DE HISTORIA DEL
;; JUEGO
;;
text_intro1:      .asciz "YOU ARE THE SHERIFF"
text_intro2:      .asciz "OF AMSTRAD, A SMALL"
text_intro3:      .asciz "TOWN. LAST NIGHT"
text_intro4:      .asciz "A GROUP OF BANDITS"
text_intro5:      .asciz "ENTERED THE TOWN"
text_historia:    .asciz "STORY"
text_in1:         .asciz "THE PLEAS OF HELP OF"
text_in2:         .asciz "THE CITIZENS WAKE"
text_in3:         .asciz "YOU UP, SO YOU GRAB"
text_in4:         .asciz "YOUR PISTOL"

show_start_game::
    call sys_render_init ;iniciamos el render
    call limpiar_pantalla
    call plantilla
    
    call texto_blanco
    ld   iy, #text_intro1         ;; Texto con el que empieza el bucle
    ld    b, #42                  ;; Coordenada Y
    ld    c, #0                   ;; Coordenada X
    ld    a, #5                   ;; Número de textos
    call  pintar_texto_seguido_enpantalla

    call esperar_tecla

    call limpiar_pantalla
    call plantilla

    call texto_blanco
    ld   iy, #text_in1          
    ld    b, #50                  ;; Coordenada Y
    ld    c, #0                   ;; Coordenada X
    ld    a, #4                   ;; Número de textos
    call  pintar_texto_seguido_enpantalla

    call esperar_tecla
    ld a,#0
    ld (showing_lore),a
ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Funcion 'plantilla'
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; No tiene INPUT
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Contiene la plantilla pricipal
;; de las pantallas de historia
;;
plantilla::

    call texto_amarillo
    ld   iy, #text_space    ;; Puntero al string
    ld    b, #160                 ;; Coordenada Y
    ld    c, #30                  ;; Coordenada X
    ld    a, #1
    call pintar_texto_seguido_enpantalla

    call texto_verde
    ld    b, #5                   ;; Coordenada Y
    ld    c, #28                  ;; Coordenada X
    ld   iy, #text_historia       ;; Puntero al string
    ld    a, #1
    call pintar_texto_seguido_enpantalla

    ret
    
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Funcion 'show_victory_screen'
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Mostramos pantalla de victoria 
;; Reiniciamos pantalla
;; Volvemos al inicio
;;
text_victory:  .asciz "NEXT LEVEL"
text_lives:    .asciz "LIVES"
text_score2:   .asciz "SCORE"
text_stage:    .asciz "STAGE CLEAR"
text_points:   .asciz "+500"
text_boss1:    .asciz "  A WAVE IS COMING"  
text_boss3:    .asciz "THE BOSS IS COMING"

show_victory_screen::
    call sys_music_set_menu
    ld l, #0x30
    call cpct_setVideoMemoryPage_asm

    ld hl, (current_buffer)
    push hl
    ld hl, #0xc000
    ld (current_buffer), hl

    call sys_render_init ;iniciamos el render

    ld   hl, #m_hud
    inc  hl
    ld   a, (hl)
    cp   #5
    jp   nz, fin_pantalla
        inc hl
        ld  a, (hl)
        cp  #1
        jp  nz, no_es_historia
            ;; CAMBIO LA APARICION DE POCINES
            ld   a,  #3
            ld   b,  #6
            ld   c,  #3
            call man_level_count_poti
            ;; HISTORIA
            ld   a, #1
            jp   ir_historia
        no_es_historia:
        cp  #2
        jp  nz, no_es_historia2
            ;; CAMBIO LA APARICION DE POCINES
            ld   a,  #5
            ld   b,  #4
            ld   c,  #4
            call man_level_count_poti
            ;; HISTORIA
            ld   a, #2
        ir_historia:
        call historia_intermedia
        jp   fin_pantalla
        no_es_historia2:
        cp #3
        jp  nz, fin_pantalla
        ld a, #1            ;; 0 = BAD ENDING // 1 = GOOD ENDING
        call show_ending
        ld a, #0
        call man_game_reset

    fin_pantalla:

    call limpiar_pantalla
    ld   hl, #m_hud
    inc  hl
    ld   a, (hl)
    inc  a
    cp   #5
    jp   nz, no_es_boss
        inc hl
        ld  a, (hl)
        cp  #3
        jp  nz, no_es_tres
            ld  iy, #text_boss3
            jp  pintar_texto
        no_es_tres:
        cp  #2
        jp  nz, es_boss_uno
            ld  iy, #text_boss1
            jp  pintar_texto
        es_boss_uno:
        ld  iy, #text_boss1
        pintar_texto:

        call texto_rojo
        ld    b, #10                  ;; Coordenada Y
        ld    c, #3                   ;; Coordenada X
        ld    a, #1
        call pintar_texto_seguido_enpantalla

    no_es_boss:

    call texto_verde
    ld    b, #50                  ;; Coordenada Y
    ld    c, #5                   ;; Coordenada X
    ld   iy, #text_victory        ;; Puntero al string
    ld    a, #4
    call pintar_texto_seguido_enpantalla

    ; Imprimir los valores del HUD
    call texto_blanco
    ld hl, #sys_render_HUD
    ld    c, #48                  ;; Coordenada X
    ld    b, #90
    call man_HUD_forall_score
    ld b, #1
    call man_HUD_next_level
    ld hl, #sys_render_HUD 
    ld    c, #56                  ;; Coordenada X
    ld    b, #50                  ;; Coordenada Y
    call man_HUD_forall_level
    ld hl, #sys_render_HUD
    ld    c, #64                  ;; Coordenada X
    ld    b, #70                  ;; Coordenada Y
    call man_HUD_forall_life

    ;; Pintamos la linea de los niveles
    ld    b, #50                  ;; Cordenada  Y
    ld    c, #60                  ;; Coordenada X
    call pintar_raya

    ;; Pintamos los puntos extra
    ld    b, #110                 ;; Coordenada Y
    ld    c, #52                  ;; Coordenada X
    ld   iy, #text_points         ;; Puntero al string
    ld    a, #1
    call pintar_texto_seguido_enpantalla

    ;; PUNTOS POR VICTORIA
    ld   b, #5
    call man_HUD_add_cien

    ; Imprimir "Press space to try again"
    call #texto_amarillo
    ld   de, #CPCT_VMEM_START_ASM ;; Puntero al principio de la memoria
    ld    b, #160                 ;; Coordenada Y
    ld    c, #30                  ;; Coordenada X
    call cpct_getScreenPtr_asm    ;; Calcula la direccion de memoria a pintar y la devuelve en HL
    ld   iy, #text_space          ;; Puntero al string
    call _myDrawStringM0          ;; Draw the string

    pop hl
    ld (current_buffer),hl

    call esperar_tecla
    ld a,#1
    call man_game_reset
ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Funcion 'historia_intermedia'
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Muestra la historia que procede mediante 
;; el juego
;;
text_bandidos:     .asciz "YOU FOUND THEIR BASE"
text_bandidos2:    .asciz "WHERE THE LEADER WAS"
text_bandidos3:    .asciz "WAITING FOR YOU"

text_canon:        .asciz "THE BANDITS FLEE TO"
text_canon2:       .asciz "THE CANYON SO YOU"
text_canon3:       .asciz "FOLLOW THEM"

historia_intermedia::

    push af
    call limpiar_pantalla
    call plantilla
    pop  af

    cp  #1
    jp  z, bandidos_historia
        ld iy, #text_bandidos
        jp end_story2
    bandidos_historia:
    ld  iy, #text_canon
    end_story2:

    call  texto_blanco
    ld    b, #50                  ;; Coordenada Y
    ld    c, #0                   ;; Coordenada X
    ld    a, #3                   ;; Número de textos
    call  pintar_texto_seguido_enpantalla
    call  esperar_tecla

ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Funcion 'show_defeat_screen'
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Mostramos pantalla de derrota 
;; Reiniciamos pantalla
;; Volvemos al inicio
;;
text_defeat:    .asciz "DEFEATED"
text_score:     .asciz "SCORE"
text_level:     .asciz "LEVEL"
show_defeat_screen::
    call sys_music_set_menu
    ld l, #0x30
    call cpct_setVideoMemoryPage_asm

    ld hl, (current_buffer)
    push hl
    ld hl, #0xc000
    ld (current_buffer), hl

    call sys_render_init ;iniciamos el render
    call limpiar_pantalla

    call texto_rojo
    ld   de, #CPCT_VMEM_START_ASM ;; Puntero al principio de la memoria
    ld    b, #30                  ;; Coordenada Y
    ld    c, #26                  ;; Coordenada X
    call cpct_getScreenPtr_asm    ;; Calcula la direccion de memoria a pintar y la devuelve en HL
    ld   iy, #text_defeat         ;; Puntero al string
    call _myDrawStringM0          ;; Draw the string

    ; Imprimir "Score"
    ; Imprimir "Level"
    ld    b, #60                  ;; Coordenada Y
    ld    c, #20                  ;; Coordenada X
    ld   iy, #text_score          ;; Puntero al string
    ld    a, #2
    call pintar_texto_seguido_enpantalla

    ; Imprimir "Press space to try again"
    call texto_amarillo
    ld   de, #CPCT_VMEM_START_ASM ;; Puntero al principio de la memoria
    ld    b, #150                 ;; Coordenada Y
    ld    c, #30                  ;; Coordenada X
    call cpct_getScreenPtr_asm    ;; Calcula la direccion de memoria a pintar y la devuelve en HL
    ld   iy, #text_space      ;; Puntero al string
    call _myDrawStringM0          ;; Draw the string

    ; Imprimir los valores del HUD
    call texto_blanco
    ld hl, #sys_render_HUD
    ld    c, #44                  ;; Coordenada X
    ld    b, #60
    call man_HUD_forall_score
    ld hl, #sys_render_HUD
    ld    c, #52                  ;; Coordenada X
    ld    b, #80                  ;; Coordenada Y
    call man_HUD_forall_level

    ld    b, #80                  ;; Cordenada  Y
    ld    c, #56                  ;; Coordenada X
    call pintar_raya

    pop hl
    ld (current_buffer),hl

    call esperar_tecla

    ld a, #0            ;; 0 = BAD ENDING // 1 = GOOD ENDING
    call show_ending

    ld a, #0
    call man_game_reset
ret

;; Declaración de los textos de controles
text_controls_title: .asciz "TUTORIAL"
text_controls_q: .asciz "Q"
text_controls_a: .asciz "A"
text_controls_o: .asciz "O"
text_controls_p: .asciz "P"
text_controls_red:   .asciz "HEALTH"
text_controls_green: .asciz "MULTI"
text_controls_blue:  .asciz "FAST"
text_controls_mute:  .asciz "MUTE"
text_controls_m:  .asciz "M"

draw_keys:
    ld de,#0xc15F
    call draw_key
    ld de,#0xc1FF
    call draw_key
    ld de,#0xc150
    call draw_key
    ld de,#0xc157
    call draw_key
    ld de,#0xc6E0
    call draw_key
    ld de,#0xc717
    call draw_key
    ld de,#0xc290
    draw_space:
    ld a,#21
    push de
    call bucle_key
    pop hl
    ld de,#0x1001
    add hl,de
    ld   iy, #text_space  ;; Puntero al string
    ld    a, #1
    call _myDrawStringM0          ;; Draw the string

ret
draw_key:
    ld a,#5
    bucle_key:
        push af
        push de
        ld hl,#_key
        ld c,#2
        ld b,#14
        call cpct_drawSprite_asm        ;(2B HL) sprite	Source Sprite Pointer (array with pixel data)
                                        ;(2B DE) memory	Destination video memory pointer
                                        ;(1B C ) width	Sprite Width in bytes [1-63] (Beware, not in pixels!)
                                        ;(1B B ) height	Sprite Height in bytes (>0)
        pop de
        inc de
        pop af
        dec a
    jp nz,bucle_key
ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Funcion 'show_ending'
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Muestra la pantalla del final del juego
;;
text_good:   .asciz "THE BAND HAS BEEN"
text_good2:  .asciz "DEFEATED.THE"
text_good3:  .asciz "CITIZENS ARE SAFE"
text_good4:  .asciz "AMSTRAD WILL PREVAIL"
text_good5:  .asciz "UNTIL 1993"
text_good6:  .asciz "GREAT JOB SHERIF!"

text_bad:    .asciz "WITH NO RESISTANCE,"
text_bad2:   .asciz "THE TOWN OF AMSTRAD"
text_bad3:   .asciz "HAS FALLEN INTO"
text_bad4:   .asciz "BANDITS POWER,BUT IT"
text_bad5:   .asciz "WILL BE REMEMBERED"
text_bad6:   .asciz "FOR 1993 MORE YEARS"

show_ending::
    ;call sys_music_set_menu
    push af
    call limpiar_pantalla
    call plantilla
    pop  af

    cp  #0
    jp  z, bad_ending
        ld iy, #text_good
        jp end_story
    bad_ending:
    ld  iy, #text_bad
    end_story:

    call  texto_blanco
    ld    b, #30                  ;; Coordenada Y
    ld    c, #0                   ;; Coordenada X
    ld    a, #6                   ;; Número de textos
    call  pintar_texto_seguido_enpantalla

    call esperar_tecla

ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Funcion 'espera_tecla'
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Espera a que la tecla de espacio sea
;; pulsada
;;
showing_lore:: .db 0
esperar_tecla::
        call check_if_mute
        ld a,(showing_lore)
        cp #1
        jp z,no_mostrar_historia
        ld hl, #Key_L
        call cpct_isKeyPressed_asm
        jp z,no_mostrar_historia
            ld a,#1
            ld (showing_lore),a
            call show_start_game
        no_mostrar_historia:
        ld hl, #Key_Space
        call cpct_isKeyPressed_asm
    jp z,esperar_tecla
ret